package heurgame;
/*
 * Created on Oct 13, 2004
 */

/**
 * @author David Kaplin
 * 
 * HuReceptors are short for "HumanReceptors"  these are the user interface
 * half of the HuClients.  They will allow direct user interaction to be
 * translated into Text that the game's protocol can understand.
 */
public interface HuReceptor {
    /**
     * Part of a contract to deliver move input to a HuClient.
     * When the HuReceptor gets this contract it yeilds its next input
     * for this particular HuClient 
     * 
     * @param h client requiring the input.
     */
    abstract public void captureMove(HuClient h);
}
