package heurgame.event;

/**
 * @author David Kaplin
 *
 * Turn Listeners should be NOT BLOCK on these methods
 * as this could quickly produce a trap that the game
 * logic may not be able comprehend.
 * 
 * Players should not implement this interface
 * 
 * The Referee blocks as a turn listener.
 * 
 * User Interface elements are more likely to be TurnListeners
 */
public interface TurnListener {
    abstract public void turnChanged(TurnEvent e);
}
