package nanomunchers.ui;

import heurgame.ui.builder.MutableTextWrapper;
import nanomunchers.event.FrameListener;
/*
 * Created on Dec 10, 2004
 */

/**
 * Controls a graphical element that displays either the total frames
 * or the current frame. 
 *
 * @author David Kaplin
 *
 */
/**
 * TODO Further documentation needed 
 *
 * @author David Kaplin
 *
 */
public class SimulationStatus implements FrameListener {
    private MutableTextWrapper display;
    
    /**
     * @param text that can be manipulated without regard to its originating toolkit.
     */
    public SimulationStatus(MutableTextWrapper text){
        display = text;
    }
    /** 
     * Sets the text to "N Frames"
     * @see nanomunchers.event.FrameListener#frameCreated(int)
     */
    public void frameCreated(int totalFrames) {
        display.setText(""+totalFrames+" Frames");
    }

    /** 
     * Sets the text to N/TotalFrames
     * @see nanomunchers.event.FrameListener#frameStarted(int, int)
     */
    public void frameStarted(int currentFrame, int totalFrames) {
        display.setText(""+currentFrame+"/"+totalFrames);
    }
}
